/*
 * MINIGUI - Harbour Win32 GUI library Demo
 * MiniGui OLE Word Demo  
 *
 * Copyright 2015-19 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2015 Grigory Filatov <gfilatov@inbox.ru>
 *
 * .  DBF  DOC     .
 * Example. Convert DBF to DOC via the OLE object in MiniGui
 * 1)    . DOC-   .
 * 2)     . DO-    .
 * 1) Without using  a  template. DOC-file is created from scratch.
 * 2) With the use of a template. DOC-file a ready resource.
*/
#include "minigui.ch"
#include "metrocolor.ch"

#define PROGRAM     "Convert DBF to DOC via the OLE object / " + MsgAboutDim(5)

REQUEST HB_CODEPAGE_RU1251, HB_CODEPAGE_RU866
REQUEST DBFCDX, DBFFPT

PROCEDURE MAIN
   LOCAL nWidth, nHeight, aBackColor, nLbl0, nLblCol
   LOCAL nJ, aDim[3], cFont := "Tahona", nFontSize := 14

   SET LANGUAGE TO RUSSIAN  
   SET CODEPAGE TO RUSSIAN  
   SET EPOCH TO ( Year(Date()) - 50 )
   SET DATE TO GERMAN

   _HMG_MESSAGE[4] := "    :" + CRLF + ; 
                      App.ExeName + CRLF + ; 
                      "  ." + CRLF + _HMG_MESSAGE[4]    
   SET MULTIPLE OFF WARNING 

   DEFINE FONT DlgFont FONTNAME "Verdana" SIZE 14
   SET MSGALERT FONTCOLOR TO BLACK
   SET MSGALERT BACKCOLOR TO { 215, 166, 0 }   // -

   RDDSETDEFAULT('DBFCDX')

   SET FONT TO cFont , nFontSize 
   
   IF !hb_mtvm()
      MsgStop ("No support for multi-threading!" + CRLF + CRLF + ;
                "Compiling with a key /mt" + CRLF )
      QUIT
   ENDIF
   
   aDim[1] := "    "  
   aDim[2] := "  OLE Word"  
   aDim[3] := MiniGUIVersion()  
 
   DEFINE WINDOW Forma_1 AT 0,0       ;
       WIDTH 760 HEIGHT 500           ;
       MAIN                           ;
       TITLE PROGRAM                  ; 
       ICON "1MAIN_ICO"               ;
       BACKCOLOR COLOR_OF2003_BLUE    ;
       NOMAXIMIZE NOSIZE              ;
       ON INIT { || OnInitForma2(), WriteDiskMyFile(), Forma_1.Image_1.Setfocus }  ;
       ON RELEASE { || OnCloseForma2() } 

       nWidth  := Forma_1.Width
       nHeight := Forma_1.Height 
       aBackColor := COLOR_OF2016_BLUE

       nLbl0 := 100
       @ 0, 0 LABEL Label_0 WIDTH nWidth HEIGHT nLbl0 VALUE "" ;
         FONT cFont SIZE nFontSize BOLD  CENTERALIGN ;
         FONTCOLOR aBackColor BACKCOLOR aBackColor  VCENTERALIGN

       @ 2, 20 IMAGE Image_1 PICTURE 'LOGO' WIDTH 96 HEIGHT 96 STRETCH ;
         TRANSPARENT BACKGROUNDCOLOR aBackColor ;
         ACTION MsgAbout() OnMouseHover RC_CURSOR( "MINIGUI_FINGER" )

       nJ := nLbl0/3 
       nLblCol := Forma_1.Image_1.Width + Forma_1.Image_1.Col + 5
       @ 0, nLblCol LABEL Label_1 WIDTH nWidth-nLblCol HEIGHT nJ VALUE aDim[1] ;
          FONT cFont SIZE nFontSize*1.3 BOLD  CENTERALIGN ;
          FONTCOLOR YELLOW BACKCOLOR aBackColor  VCENTERALIGN
       @ nJ*1, nLblCol LABEL Label_2 WIDTH nWidth-nLblCol HEIGHT nJ VALUE aDim[2] ;
          FONT cFont SIZE nFontSize*1.3 BOLD  CENTERALIGN ;
          FONTCOLOR YELLOW BACKCOLOR aBackColor  VCENTERALIGN
       @ nJ*2, nLblCol LABEL Label_3 WIDTH nWidth-nLblCol HEIGHT nJ VALUE aDim[3] ;
          FONT cFont SIZE nFontSize BOLD  CENTERALIGN ;
          FONTCOLOR YELLOW BACKCOLOR aBackColor  VCENTERALIGN

       @ nLbl0 + 20, 20  LABEL Label_Word VALUE "Version Word" ;
         WIDTH nWidth-40 HEIGHT 60 FONTCOLOR BLACK BOLD TRANSPARENT 

       @ 200,40 BUTTONEX Button_1Doc CAPTION '  1' + CRLF +'( DOC-)';
          WIDTH 420 HEIGHT 110 BACKCOLOR COLOR_BLUE_BLUE FONTCOLOR WHITE BOLD ;
          ICON "Word64" NOXPSTYLE HANDCURSOR ACTION {|| Forma_1.Minimize, DocReport1() }

       @ 320,40 BUTTONEX Button_2Doc CAPTION '  2' + CRLF +'( DOC-)';
          WIDTH 420 HEIGHT 110 BACKCOLOR COLOR_BLUE_FB  FONTCOLOR WHITE BOLD ;
          ICON "Word64" NOXPSTYLE HANDCURSOR ACTION {|| Forma_1.Minimize, DocReport2() }

       @ 200,470 BUTTONEX Button_Help CAPTION ' ' ;
          WIDTH 250 HEIGHT 110 BACKCOLOR COLOR_YELLOW_METRO FONTCOLOR WHITE BOLD ;
          ICON "help64" NOXPSTYLE HANDCURSOR ACTION  {|| MsgAbout() }

       @ 320,470 BUTTONEX Button_Exit CAPTION ' ' + CRLF +'' ;
          WIDTH 250 HEIGHT 110 BACKCOLOR COLOR_RED_METRO FONTCOLOR WHITE BOLD ;
          ICON "Close64" NOXPSTYLE HANDCURSOR ACTION  {|| ThisWindow.Release }

   END WINDOW

   CENTER WINDOW Forma_1
   ACTIVATE WINDOW Forma_1

RETURN

/////////////////////////////////////////////////////////////////
FUNCTION OnInitForma2()
  LOCAL cInfo, cPath, aRet := {1,""}

  aRet := MyWordVersion()
  cInfo := ":  " + aRet[2] + "  (" + HB_NtoS(aRet[1]) + ")" + CRLF

  cPath := MyWordPath()
  cPath := IIF( cPath == NIL, "???????", cPath)
  cInfo += "  Word:  " + cPath

  Forma_1.Label_Word.Value := cInfo
  Forma_1.Image_1.Setfocus

  RETURN NIL

////////////////////////////////////////////////////////////////
//         
FUNCTION OnCloseForma2(aFile)
   DEFAULT aFile := {} 
   //DELETEFILE(aFile[1])
   RETURN NIL

//////////////////////////////////////////////////////////////////
//   .  DOC-   .
FUNCTION DocReport1()   
   LOCAL cFileDbf := GetStartUpFolder() +"\test1.dbf"
   LOCAL cFileDoc := GetStartUpFolder() +"\test1.doc"
   LOCAL cErrDoc  := GetStartUpFolder() +"\~$test1.doc"
   LOCAL cMsg, nTime, cTitle, lActivate, lSave, aDimDbf
   LOCAL nOrder, aField, aHead, aHeadClr, aFooting
   LOCAL cFileIndex := cFileDbf + "0.cdx"
   DEFAULT cFileDoc := ""

   IF !FILE(cFileDbf)
      cMsg := " !    !;;" 
      cMsg += cFileDbf + ";;"
      cMsg += "   !;  !" 
      MyStop(cMsg, "")
      Forma_1.Restore
      RETURN NIL
   ENDIF
   nTime := SECONDS()

   Forma_1.Button_1Doc.Enabled := .F. //   / lock button
                                                   
   aField := {}             ; aHead  := {} //     
   AADD( aField, "NN"     ) ; AADD( aHead, ";/"                     ) 
   AADD( aField, "PRODUCT") ; AADD( aHead, " "             ) 
   AADD( aField, "NACISL" ) ; AADD( aHead, "; ;(.)"    ) 
   AADD( aField, "PRIXOD" ) ; AADD( aHead, "; ;(.)"     ) 
   AADD( aField, "ITOGO"  ) ; AADD( aHead, ";(.)"                ) 
   AADD( aField, "SUMDOG" ) ; AADD( aHead, ";-;"     ) 
   AADD( aField, "KOLVO"  ) ; AADD( aHead, ";-;"        ) 
   AADD( aField, "DATE2"  ) ; AADD( aHead, ";;"       ) 

   WaitThreadCreate( "    ..." )   //   -> WaitThread.prg

   USE ( cFileDbf ) Alias SPISOK1 CODEPAGE "RU1251" VIA "DBFCDX" NEW EXCLUSIVE
   INDEX ON "SPISOK1->NN" TAG MAIN1 TO ( cFileIndex ) 
   ORDLISTADD( cFileIndex )
   nOrder := 1
   aDimDbf := MyLoadDbftoDim( "SPISOK1",nOrder, aField )
   CLOSE SPISOK1
   DELETEFILE(cFileIndex)

   DELETEFILE(cErrDoc)  //      Word 

   WaitThreadClose()  //     -> WaitThread.prg

   cTitle    := "  ()   2   2014."
   aHeadClr  := { YELLOW, COLOR_BLUE_BLUE, 14 }   //    
   aFooting  := {"","/ ../"}    //   
   lActivate := .T.  //   
   lSave     := .T.  //   
   MyWord1Ole( cFileDoc, lActivate, lSave, cTitle, aHead, aDimDbf, aHeadClr, aFooting )

   Forma_1.Button_1Doc.Enabled := .T. //   / unlock button
   //Forma_1.Restore  //      

   RETURN NIL

/////////////////////////////////////////////////////////////////////////////
//   . DO-      
//        -.
FUNCTION DocReport2()  
   LOCAL cFileDbf  := GetStartUpFolder() +"\test2.dbf"
   LOCAL cFile2Dot := GetStartUpFolder() +"\test2shablon.doc"
   LOCAL cFile2Doc := GetStartUpFolder() +"\test2.doc"
   LOCAL cErr2Doc  := GetStartUpFolder() +"\~$test2.doc"
   LOCAL cMsg, nTime, lActivate
   LOCAL nOrder, aField, aDocVal, aDimDbf
   LOCAL cFileIndex := cFileDbf + "0.cdx"

   IF !FILE(cFileDbf)
      cMsg := " !    !;;" 
      cMsg += cFileDbf + ";;"
      cMsg += "   !;  !" 
      MyStop(cMsg, "")
      Forma_1.Restore
      RETURN NIL
   ENDIF
   nTime := SECONDS()

   Forma_1.Button_2Doc.Enabled := .F. //   / lock button

   aDocVal := {}   //  public  (  private)  
   AADD( aDocVal, { "M->Date1"  , "01.09.2016" }  )                       
   AADD( aDocVal, { "M->Date2"  , "30.09.2016" }  )                       
   AADD( aDocVal, { "M->SumIsp" , "15 900 (  )"   }  )                       
   AADD( aDocVal, { "M->Isp1"   , " :" }  )                       
   AADD( aDocVal, { "M->Isp2"   , " .."     }  )                       
   AADD( aDocVal, { "M->Zak1"   , " :"   }  )                       
   AADD( aDocVal, { "M->Zak2"   , " .."     }  )                       
   AADD( aDocVal, { "M->Zak3"   , "    " }  )                       

   aField := {}   //   
   AADD( aField, "NUMZA"  ) //  /                      
   AADD( aField, "DATEZA" ) //                  
   AADD( aField, "STREET" ) //                       
   AADD( aField, "DOM"    ) //                         
   AADD( aField, "KORP"   ) //                      
   AADD( aField, "KVAR"   ) //                    
   AADD( aField, "REMZA"  ) //    
   AADD( aField, "KOLVO"  ) //  (.)           
                                                   
   WaitThreadCreate( "    ..." )   //   -> WaitThread.prg

   USE ( cFileDbf ) Alias SPISOK2 CODEPAGE "RU866" VIA "DBFCDX" NEW EXCLUSIVE
   INDEX ON "STOD(DATEZA)" TAG MAIN2 TO ( cFileIndex ) 
   ORDLISTADD( cFileIndex )
   nOrder := 1
   aDimDbf := MyLoadDbftoDim("SPISOK2",nOrder,aField)
   CLOSE SPISOK2
   DELETEFILE(cFileIndex)

   DELETEFILE(cErr2Doc)  //      Word 

   WaitThreadClose()  //     -> WaitThread.prg

   lActivate := .T.  //  Word   
   MyWord2Ole( cFile2Doc, cFile2Dot, lActivate, aDimDbf, aDocVal )
  
   Forma_1.Button_2Doc.Enabled := .T. //   / unlock button
   //Forma_1.Restore  //      

   RETURN NIL

//////////////////////////////////////////////////////////////////////////
FUNCTION MyLoadDbftoDim(cAlias,nOrder,aField)  //   
   LOCAL nI, nJ, aDim := {}, aTmp, nRecAll

   SELECT(cAlias)
   DbSetOrder(nOrder)
   nRecAll := ORDKEYCOUNT()
   FOR nI := 1 TO nRecAll
      ORDKEYGOTO( nI )
      aTmp := {}
      FOR nJ := 1 TO LEN(aField)
         AADD( aTmp, FIELDGET(FIELDPOS(aField[nJ])) )
      NEXT
      AADD( aDim, aTmp )
      INKEYGUI(200)
   NEXT
   
   RETURN aDim

//////////////////////////////////////////////////////////////////////////
FUNCTION MyStop(cMsg,cTitle) 
   LOCAL bInit := {|| this.topmost := .t. }
   DEFAULT cTitle := ""

   SET MSGALERT FONTCOLOR TO MAROON
   SET MSGALERT BACKCOLOR TO { 255, 178, 178 }

   cMsg := AtRepl( ";", cMsg, CRLF )

   HMG_Alert( cMsg, {"&"}, cTitle, Nil, "Stop64", 64, { {189, 30, 73} } , bInit ) 

   RETURN NIL

//////////////////////////////////////////////////////////////////////////
FUNCTION MyInfo(cMsg,cTitle) 
   LOCAL bInit := {|| this.topmost := .t. }
   DEFAULT cTitle := ""

   SET MSGALERT FONTCOLOR TO BLACK
   SET MSGALERT BACKCOLOR TO { 141, 179, 226 }   

   cMsg := AtRepl( ";", cMsg, CRLF )

   HMG_Alert( cMsg, {"&"}, cTitle, Nil, "Smile64", 64, { {84,141,212} } , bInit ) 

   RETURN NIL

//////////////////////////////////////////////////////////////////////////
FUNCTION MyExclam(cMsg,cTitle) 
   LOCAL bInit := {|| this.topmost := .t. }
   DEFAULT cTitle := ""

   SET MSGALERT FONTCOLOR TO BLACK
   SET MSGALERT BACKCOLOR TO { 238, 249, 142 }   // -

   cMsg := AtRepl( ";", cMsg, CRLF )

   HMG_Alert( cMsg, {"&"}, cTitle, Nil, "Smile64", 64, { COLOR_YELLOW_METRO } , bInit ) 

   RETURN NIL
