/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016-2019 Verchenko Andrey <verchenkoag@gmail.com> Dmitrov, Moscow region
 * Copyright 2018 Sidorov Aleksandr <aksidorov@mail.ru> Dmitrov, Moscow region
 * Copyright 2016 Pavel Tsarenko <tpe2@mail.ru>
*/

#include "minigui.ch"
#include "word.ch"
/////////////////////////////////////////////////////////////////////////////
FUNCTION MyWord2Ole( cFileDoc, cFileDot, lActivate, aDimDbf, aDocVal )
   LOCAL cMsg, nStatus, oWord, oActive, oMarks, oDocs, oSelect 

   CursorWait()
   //     
   WaitThreadCreate( '   Word ...' )

   // -------    Word ---------------
   //  Ole  HBWIN.lib
   IF ( oWord := win_oleCreateObject( "Word.Application" ) ) == NIL 
      WaitThreadClose()  //   
      CursorArrow()
      cMsg := "MS Word   !;; "
      cMsg += " [ " + win_oleErrorText() + " ];;"
      MyStop( cMsg , "!" )
      RETURN NIL 
   ENDIF

   //   ,    
   nStatus := hb_FCopy( cFileDot, cFileDoc )
   IF nStatus # 0
      WaitThreadClose()   //   
      cMsg := " " + cFileDot + "    " + cFileDoc + ";"
      cMsg += " ("+HB_NtoS(nStatus)+") DosErr="+HB_NtoS(DosError())+";;"
      cMsg += "       !;"
      cMsg += "      !;"
      cMsg += "     !;;"
      cMsg += "     Word'a !;"
      cMsg += "      !"
      MyStop( cMsg )
      RETURN NIL
   ENDIF

   // --------------   ------------------
   //oWord := TOleAuto():New( "Word.Application" )
   oDocs := oWord:Documents
   oDocs:Open( cFileDoc )
   oActive := oWord:ActiveDocument
   oSelect := oWord:Selection
   oMarks  := oActive:BookMarks

   //         doc
   MyDocFindRepl(oWord, aDocVal)

   //         doc
   MyDocTable(oWord, oSelect, aDimDbf)

   //        doc
   MyDocFooter(oActive)

   // --------------   ------------------
 
   WaitThreadClose()   //   
   CursorArrow()

   oWord:Visible     := lActivate //  Word  
   oWord:WindowState := 1         // Maximize
   oWord:Selection:HomeKey(6)     //  

   oActive:SaveAs( cFileDoc )     //   

   WordWindowToForeground(oWord)  //  Word   

   RETURN NIL

///////////////////////////////////////////////////////////////////////////////////////////
//         doc 
FUNCTION  MyDocFindRepl(oWord, aDocVal)
   LOCAL nI, oFind, cFind, cReplace

   oFind := oWord:Selection:Find
   FOR nI := 1 TO LEN(aDocVal)

       cFind    := "#"+aDocVal[nI,1]
       cReplace := CStr( aDocVal[nI,2] ) //     

       oFind:ClearFormatting()
       oFind:Replacement:ClearFormatting()
       oFind:Text := cFind //"#M->Date1"
       oFind:Replacement:Text := cReplace //"01/01/2016"
       oFind:Forward := .T.
       //oFind:Wrap := 1 
       oFind:Wrap = wdFindContinue 
       oFind:Format = .F. 
       oFind:MatchCase = .F. 
       oFind:MatchWholeWord = .F. 
       oFind:MatchWildcards = .F. 
       oFind:MatchSoundsLike = .F. 
       oFind:MatchAllWordForms = .F. 

       oFind:Execute(cFind,0,0,0,0,0,1,1,0,cReplace,wdReplaceAll)

   NEXT

   RETURN NIL

///////////////////////////////////////////////////////////////////////////////////////////
//         doc
FUNCTION MyDocTable(oWord, oSelect, aDimDbf)
   LOCAL nI, nJ, oTbl, nRow, nCol, aRow, nColDbf
   LOCAL cVal, xVal, nRowDbf, nRows

   oTbl:= oWord:ActiveDocument:Tables:Item(1)
   //  
   nRow := oTbl:Rows:Count
   //  
   nCol := oTbl:Columns:Count

   nColDbf := LEN(aDimDbf[1])
   IF nCol # nColDbf
      MsgStop( "-      -    !", "!" )
   ENDIF

   nRowDbf := LEN(aDimDbf)  // -    (   )

   nRows := 1  //  ,     . 
               //     .
               //    .

   IF ! Empty(oTbl)

      oTbl:Cell(2, 1):Range:Select() //   2  

      FOR nI := 1 TO LEN(aDimDbf)

          aRow := aDimDbf[nI]      //  

          IF nI > nRows
             oSelect:InsertRowsBelow()  //    
          ENDIF
          //    
          FOR nJ := 1 TO LEN(aRow)
             xVal := aRow[nJ]
             IF xVal # Nil
                cVal := IIF( VALTYPE(xVal) == "D", DTOC(xVal), ALLTRIM( CStr(xVal) ) )
                oSelect:TypeText(cVal)
                IF VALTYPE(xVal) == "C"
                   oSelect:ParagraphFormat:Alignment:= wdAlignParagraphLeft
                ELSE
                   oSelect:ParagraphFormat:Alignment:= wdAlignParagraphCenter
                ENDIF
             ENDIF
             oSelect:MoveRight(1, 1)
          NEXT

          ProcessMessages()  //  !     

      NEXT

   ELSE
      MsgStop( "  ,     !", "!" )
   ENDIF

   RETURN NIL

///////////////////////////////////////////////////////////////////////////////////////////
//        doc
// The function to replace and insert the footer in doc
FUNCTION MyDocFooter(oActive)
   Local footerRange, oSection, ofooterRange, oRange 
   Local aFColor, nI, aStroka, cStroka := ""

   aStroka := { "   1", "   2", "   3" }
   For nI := 1 TO LEN(aStroka)
      cStroka += aStroka[nI]
      If nI != LEN(aStroka)
         cStroka += CRLF 
      Endif
   Next

   aFColor := RED //  
   oSection := oActive:Sections[1]
   ofooterRange  := oSection:Footers
   footerRange := ofooterRange[wdHeaderFooterPrimary]
   oRange := footerRange:Range
   oRange:Font:Color :=  RGB(aFColor[1],aFColor[2],aFColor[3])
   oRange:Font:Name := "Times New Roman"   
   oRange:Font:Size := 14
   oRange:Font:Bold := .T.
   oRange:Text = cStroka 
   oRange:ParagraphFormat:Alignment = wdAlignParagraphCenter

   RETURN NIL

///////////////////////////////////////////////////////////////////////////////////////////
//    WinWord
FUNCTION MyWordVersion()
   LOCAL nVer, aDim[20], Ob, cVer, cPathWord

   AFILL(aDim,"???")
   aDim[01] := " Word   !"
   aDim[09] := "Word 2000"
   aDim[10] := "Word XP"
   aDim[11] := "Word 2003"
   aDim[12] := "Word 2007"
   aDim[14] := "Word 2010"
   aDim[15] := "Word 2013"
   aDim[16] := "Word 2016"
   aDim[17] := "Word 2019"
   aDim[18] := "Word New!"

   cPathWord := MyWordPath() 
   IF !FILE(cPathWord + "Winword.exe")
      nVer := 1
   ELSE
      Ob:= win_oleCreateObject("Scripting.FileSystemObject")
      cVer := Ob:GetFileVersion( cPathWord + "Winword.exe" ) 
      nVer := VAL( SUBSTR(cVer,1, AT(".",cVer)) )
   ENDIF

   RETURN { nVer, aDim[nVer] }

///////////////////////////////////////////////////////////////////////////////////////////
FUNCTION MyWordPath()
 LOCAL cPath := NIL 
 cPath := win_regRead( "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\Winword.exe\Path" )
 IF cPath == NIL
    cPath := ""
 ENDIF
Return cPath 

